using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using mbe;
using CE3IO;

namespace jtext4mbe
{
	class PreviewCtrl : ScrollableControl
	{
		/// <summary>
		/// View3DGbW邽߂̃EBhEX^C̐ݒs
		/// </summary>
		protected override CreateParams CreateParams
		{
			get
			{
				CreateParams cp = base.CreateParams;
				cp.ExStyle &= (~Win32WindowProperty.WS_EX_CLIENTEDGE);
				cp.Style &= (~Win32WindowProperty.WS_BORDER);
				cp.ExStyle |= Win32WindowProperty.WS_EX_CLIENTEDGE;
				return cp;
			}
		}

		public PreviewCtrl()
		{
			//_uobt@Oݒ
			this.SetStyle(ControlStyles.DoubleBuffer, true);
			this.SetStyle(ControlStyles.AllPaintingInWmPaint, true);
			this.SetStyle(ControlStyles.OptimizedDoubleBuffer, true);

			lineDataList = new LinkedList<LineData>();
			stringWidth = 0;
			textHeight = 64;
			lineWidth = 3;
            drawScale = 2.0;
            widthScalse = 100;

			//Size sz = ClientSize;
			//AutoScrollMinSize = sz;
		
		}

        protected override void OnScroll(ScrollEventArgs se)
        {
            //2008/12/20 Version 0.11.01
            //uhbOɃEBhE̓e\vOFFɂȂĂƂɁA
            //ThumbTrackAutoScrollPositionXVȂƂ̑΍
            //System.Diagnostics.Debug.WriteLine("OnScroll():" + se.Type + "," + se.NewValue);
            //System.Diagnostics.Debug.WriteLine("OnPaint():" + AutoScrollPosition);
            if (se.Type == ScrollEventType.ThumbTrack) {
                Point ptScrlPos = AutoScrollPosition;

                if (se.ScrollOrientation == ScrollOrientation.HorizontalScroll) {
                    if (ptScrlPos.X != -se.NewValue) {
                        AutoScrollPosition = new Point(se.NewValue, -ptScrlPos.Y);
                    }
                } else {
                    if (ptScrlPos.Y != -se.NewValue) {
                        AutoScrollPosition = new Point(-ptScrlPos.X, se.NewValue);
                    }
                }

            }
            base.OnScroll(se);
        }

		protected override void OnPaint(PaintEventArgs e)
		{
			base.OnPaint(e);

			//if (!enablePaint) return;

			Graphics g=e.Graphics;
			g.Clear(Color.Black);

            if (lineDataList == null) return;

			if (lineDataList.Count == 0) return;
            Point ptAutoScrollPos = this.AutoScrollPosition;

            System.Diagnostics.Debug.WriteLine("OnPaint ScrollPos(" + ptAutoScrollPos.X + ":" + ptAutoScrollPos.Y+")");

            g.TranslateTransform(ptAutoScrollPos.X, ptAutoScrollPos.Y);




            double drawHeight = 32 * drawScale;
            double dWidthScalse = (double)widthScalse / 100;


			double d = drawHeight / textHeight;
			int drawLineWidth = (int)(lineWidth * d);
			Size szClient = ClientSize;

			int xOrg = 10;
			int yOrg = (int)((szClient.Height - drawHeight) / 2);

			Color col = Color.Orange;
			Pen pen = new Pen(col, drawLineWidth);
			pen.StartCap = LineCap.Round;
			pen.EndCap = LineCap.Round;

			foreach (LineData lineData in lineDataList) {
                int x0 = (int)(lineData.p0.X * drawScale * dWidthScalse + xOrg);
                int y0 = szClient.Height - (int)(lineData.p0.Y * drawScale + yOrg);
                int x1 = (int)(lineData.p1.X * drawScale * dWidthScalse + xOrg);
                int y1 = szClient.Height - (int)(lineData.p1.Y * drawScale + yOrg);
				g.DrawLine(pen, x0, y0, x1, y1);
			}
			pen.Dispose();


		}

		public LinkedList<LineData> lineDataList;
		public int stringWidth;
		public int textHeight;
		public int lineWidth;
        public int widthScalse;
        public double drawScale;

	}

	class Win32WindowProperty
	{
		public const int WS_EX_CLIENTEDGE = unchecked((int)0x00000200);
		public const int WS_BORDER = unchecked((int)0x00800000);
	}
}
